clear
%input data
EbN0dB=10.19;
D=200; %metri
Rb=1e6;%bit/s
N=1000;%bit
Nt=2; %numero massimo tentativi
nbmax=5; %numero massimo di blocchi errati considerati nell'analisi
%parametri codice
n=63;
k=57;
t=1;
l=0;
sim=1;
lnsim=1e6;
%calcolo probabilità errore bit
EbN0=10^(EbN0dB/10);
Rc=k/n;
binaria_antipodale=0;
if binaria_antipodale
    pb=1/2*erfc((EbN0*Rc)^.5);
else
    pb=5/8*erfc((3/5*EbN0*Rc)^.5); %provetta
end
%probabilità di ne errori in n bit, ne compreso tra 0 e tc+2l
tc=t-l;
ne=0:tc+2*l;
pne=pb.^(ne).*(1-pb).^(n-ne).*binV(n,ne);
%probabilità corretta ricezione del blocco
pcb=sum(pne(1:tc+1));
if l>0, pdb=sum(pne(tc+2:tc+2*l+1)); else, pdb=0; end
peb=1-pcb-pdb;
str=sprintf('pr. corretta rx bl.:%.3e, pr. det. bl.:%.2e, pr. errata rx bl.:%.2e',pcb,pdb,peb);
disp(str);
%probabilità corretta ricezione del pacchetto
Nb=ceil(N/k);
pcp=pcb^Nb;
str=sprintf('pr. corretta rx pacchetto.:%.3e',pcp);
disp(str);
%probabilità di ricevere il pacchetto corretto in nrip (numero di ripetizioni)
nrip=1:Nt;
pcnrip=pcp.*(1-pcp).^(nrip-1);
pct=sum(pcnrip);
str=sprintf('pr. corretta rx pacchetto entro %d tentativi.:%.2e',Nt,pct);
disp(str);
%calcolo ritardo
tau=D/3e8;
H=Nb*n/Rb;
tciclo=H+2*tau;
ttot=tciclo*(1:Nt)*pcnrip'/pct;
str=sprintf('ritardo medio:%.3f [ms], ritardo max:%.3f [ms]',ttot*1000,tciclo*Nt*1000);
disp(str);
%ripetizione solo dei blocchi errati
if l>0 && Nt==2
    nbe=1:nbmax;
    %probabilità nbe blocchi errati
    pbne=pcb.^(Nb-nbe).*(1-pcb).^nbe.*binV(Nb,nbe); %probabilità incondizionata nbe errori al primo ciclo
    pbnec=pbne/(1-pcp); %probabilità condizionata errori primo ciclo/errore
    pcnrips=[pcp sum(pbne.*pcb.^nbe)]; %al secondo colpo devono arrivare corretti
    pcts=sum(pcnrips);
    Hb=n/Rb;
    txs(1)=tciclo;    
    txs(2)=tciclo+2*tau+Hb*nbe*pbnec';
    ttots=txs*pcnrips'/pcts;
    str=sprintf('ritardo medio rip. selettiva:%.3f [ms]',ttots*1000);
    disp(str);
    str=sprintf('pr. successo rip. selettiva:%.3e',pcts);
    disp(str);
end
if sim==1 && binaria_antipodale==1
    varnoise=1/(2*EbN0*Rc);
    %[G,H,gn,dmin] = buildGBCHcyclic(n,k,gen,0);
    ter=0;
    for i=1:lnsim
        noise=randn(1,n)*varnoise^.5;
        er=sum(noise>1);
        ter=ter+(er>tc);
    end
    str=sprintf('pr. corretta rx di blocco simulata: %.3e',1-ter/lnsim);
    disp(str);
end



