%=================================================================
%buildGBCH.m
%build Generatormatrix of a systematic BCH code
%The calling syntax is:
%		[G,H] = buildGBCH(n,k)
%Inputs:
%   n,k: code parameters
%Outputs:
%   Generator matrix, Parity check matrix
%=================================================================
function [G,H] = buildGBCH(n,k)
G=zeros(k,n);
H=zeros(n-k,n);
for i=1:k
    x=zeros(1,k);
    x(i)=1;
    y=gf(x);
    c=bchenc(y,n,k);
    G(i,:)=gf2bin(c);
end
H(:,1:k)=G(:,k+1:n)';
H(:,k+1:n)=eye(n-k);